<template>
  <div class="grid grid--wrapper">
    <the-header></the-header>
    <main class="content">
      <router-view v-slot="slotProps">
        <transition name="route" mode="out-in">
          <component :is="slotProps.Component"></component>
        </transition>
      </router-view>
    </main>
  </div>
</template>

<script>
import TheHeader from "./components/layout/TheHeader.vue";

export default {
  title: "Invoice | Frontend Mentor",
  components: {
    TheHeader,
  },
};
</script>

<style>
@import url("https://fonts.googleapis.com/css2?family=League+Spartan:wght@400;500;700&display=swap");
/* ------------------- */
/* Custom properties   */
/* ------------------- */

:root {
  /* colors */
  --clr-primary-100: 252, 94%, 67%;
  --clr-primary-200: 252, 100%, 73%;

  --clr-neutral-100: 0, 0%, 100%;
  --clr-neutral-400: 231, 20%, 61%;

  --clr-danger: 0, 80%, 63%;
  --clr-danger-hover: 0, 100%, 80%;
  --clr-warning: 34, 100%, 50%;
  --clr-success: 160, 67%, 52%;

  --clr-body-bg: 233, 30%, 11%;
  --clr-sidebar-bg: 233, 31%, 17%;
  --clr-form-bg: 233, 30%, 11%;
  --clr-form-field-bg: 233, 31%, 17%;
  --clr-form-field-border: 233, 30%, 21%;
  --clr-form-field-border-hover: 252, 100%, 73%;

  --clr-btn-primary-bg: 252, 94%, 67%;
  --clr-btn-primary-hover: 252, 100%, 73%;
  --clr-btn-primary-text: 231, 73%, 93%;

  --clr-btn-secondary-bg: 233, 30%, 21%;
  --clr-btn-secondary-hover: 0, 0%, 100%;
  --clr-btn-secondary-text: 231, 73%, 93%;

  --clr-btn-tertiary-bg: 230, 21%, 27%;
  --clr-btn-tertiary-hover: 233, 31%, 17%;
  --clr-btn-tertiary-text: 231, 73%, 93%;

  --clr-btn-quaternary-bg: 233, 30%, 21%;
  --clr-btn-quaternary-hover: 233, 31%, 17%;
  --clr-btn-quaternary-text: 231, 73%, 93%;

  --clr-invoice-item-bg: 233, 31%, 17%;
  --clr-invoice-status-bg: 231, 73%, 93%;
  --clr-invoice-status-text: 231, 73%, 93%;
  --clr-invoice-table-bg: 233, 30%, 21%;
  --clr-invoice-table-footer-bg: 228, 29%, 7%;

  --clr-popup-bg: 233, 31%, 17%;

  --clr-dropdown-bg: 233, 30%, 21%;
  --clr-dropdown-shadow: rgba(0, 0, 0, 0.25);

  --clr-checkbox-bg: 233, 31%, 17%;

  --clr-text-heading: 0, 0%, 100%;
  --clr-text-body-a: 231, 73%, 93%;
  --clr-text-body-b: 0, 0%, 100%;
  --clr-text-form-label: 231, 73%, 93%;
  --clr-text-placeholder: 0, 0%, 100%;

  /* font-sizes */
  --fs-body: 0.9rem;

  /* font-families */
  --ff-primary: "League Spartan", sans-serif;
  /* font-weights */
  --fw-400: 400;
  --fw-500: 500;
  --fw-700: 700;
}

/* Define styles for the root window with dark - mode preference */
:root.dark-theme {
  --clr-body-bg: 240, 27%, 98%; /** */
  --clr-sidebar-bg: 231, 20%, 27%; /** */
  --clr-form-bg: 0, 0%, 100%; /** */
  --clr-form-field-bg: 0, 0%, 100%; /** */
  --clr-form-field-border: 231, 73%, 93%;

  --clr-btn-primary-bg: 252, 94%, 67%;
  --clr-btn-primary-hover: 252, 100%, 73%;
  --clr-btn-primary-text: 231, 73%, 93%;

  --clr-btn-secondary-bg: 228, 71%, 99%;
  --clr-btn-secondary-hover: 231, 73%, 93%;
  --clr-btn-secondary-text: 231, 37%, 63%;

  --clr-btn-tertiary-bg: 230, 21%, 27%;
  --clr-btn-tertiary-hover: 228, 29%, 7%;
  --clr-btn-tertiary-text: 231, 20%, 61%;

  --clr-btn-quaternary-bg: 228, 71%, 99%;
  --clr-btn-quaternary-hover: 231, 73%, 93%;
  --clr-btn-quaternary-text: 231, 37%, 63%;

  --clr-invoice-item-bg: 0, 0%, 100%; /** */
  --clr-invoice-status-bg: 231, 20%, 27%;
  --clr-invoice-status-text: 231, 20%, 27%;
  --clr-invoice-table-bg: 228, 71%, 99%; /** */
  --clr-invoice-table-footer-bg: 231, 20%, 27%; /** */

  --clr-popup-bg: 0, 0%, 100%; /** */

  --clr-dropdown-bg: 0, 0%, 100%; /** */
  --clr-dropdown-shadow: rgba(72, 84, 159, 0.25); /** */

  --clr-checkbox-bg: 231, 73%, 93%; /** */

  --clr-text-heading: 228, 29%, 7%;
  --clr-text-body-a: 231, 20%, 61%;
  --clr-text-body-b: 228, 28%, 7%;
  --clr-text-form-label: 231, 37%, 63%; /** */
  --clr-text-placeholder: 228, 29%, 7%, 0.4;
}
/* Box sizing rules */
*,
*::before,
*::after {
  box-sizing: border-box;
}

/* Remove default margin */
body,
h1,
h2,
h3,
h4,
p,
figure,
blockquote,
dl,
dd {
  margin: 0;
}

/* Remove list styles on ul, ol elements with a list role, which suggests default styling will be removed */
ul[role="list"],
ol[role="list"] {
  list-style: none;
}

/* Set core root defaults */
html:focus-within {
  scroll-behavior: smooth;
}

/* Set core body defaults */
body {
  min-height: 100vh;
  text-rendering: optimizeSpeed;
  line-height: 1.5;
}

/* A elements that don't have a class get default styles */
a:not([class]) {
  text-decoration-skip-ink: auto;
}

/* Make images easier to work with */
img,
picture {
  max-width: 100%;
  display: block;
}

/* Inherit fonts for inputs and buttons */
input,
button,
textarea,
select {
  font: inherit;
}

/* Remove all animations, transitions and smooth scroll for people that prefer not to see them */
@media (prefers-reduced-motion: reduce) {
  html:focus-within {
    scroll-behavior: auto;
  }

  *,
  *::before,
  *::after {
    animation-duration: 0.01ms !important;
    animation-iteration-count: 1 !important;
    transition-duration: 0.01ms !important;
    scroll-behavior: auto !important;
  }
}

/* ------------------- */
/* Utility classes     */
/* ------------------- */

/* general */

.flex {
  display: flex;
  gap: var(--gap, 1rem);
  align-items: center;
}

.grid {
  display: grid;
  gap: var(--gap, 1rem);
}
.d-block-ls {
  display: none;
}
@media (min-width: 56.25em) {
  .d-block-ls {
    display: inline-block;
  }
}

.text-neutral-100 {
  color: hsl(var(--clr-neutral-100));
}
.text-neutral-400 {
  color: hsl(var(--clr-neutral-400));
}
.text-body-a {
  color: hsl(var(--clr-text-body-a));
}

/* typography */

.fw-400 {
  font-weight: var(--fw-400);
}
.fw-500 {
  font-weight: var(--fw-500);
}
.fw-700 {
  font-weight: var(--fw-700);
}
main {
  --gap: 1rem;
}
.content {
  grid-area: content;
  overflow: auto; /* overflow condition on parent */
}
.container {
  padding-inline: 2em;
  margin-inline: auto;
  margin-block: 2rem;
  max-width: 40rem;
}
@media (min-width: 56.25em) {
  .container {
    margin-block: 4rem;
  }
}
/* set up the body */
body {
  font-family: var(--ff-primary);
  font-size: var(--fs-body);
  color: hsl(var(--clr-text-body-b));
  background: hsl(var(--clr-body-bg));
  overflow-x: hidden;
  transition: background 500ms;
}
.grid--wrapper {
  --gap: 0;
  grid-template-rows: 5rem calc(100vh - 5rem); /* height limitation on second row */
  grid-template-areas:
    "header "
    "content";
}
@media (min-width: 56.25em) {
  .grid--wrapper {
    grid-template-rows: 1fr; /* height limitation on second row */
    grid-template-columns: 6rem 1fr; /* height limitation on second row */
    grid-template-areas: "header content";
  }
}
.route-enter-active,
.route-leave-active {
  transition: opacity 0.5s ease;
}
.route-enter-from,
.route-leave-to {
  opacity: 0;
}
</style>
